<template lang="pug">
    v-card
        v-card-title Masonry
        v-card-text
            question(
                v-for="question in questions"
                @input="grabChange(question.name, $event)"
                :question="question"
            )

</template>

<script>
import question from "../Question_Wrapper.vue";
export default {
    name: "Masonry",
    props: {
        options: {
            required: true,
            type: Object
        },
        masonry: {
            required: true,
            type: Object
        }
    },
    data: function() {
        return {
            localMasonry: null,
            questions: [
                {
                    label: "Materials",
                    type: "text",
                    name: "materials",
                    value: this.masonry.materials
                },
                {
                    label: "Size of Materials",
                    type: "text",
                    name: "size_materials",
                    value: this.masonry.size_materials
                },
                {
                    label: "Finish",
                    type: "text",
                    name: "finish",
                    value: this.masonry.finish
                },
                {
                    label: "Bond",
                    type: "text",
                    name: "bond",
                    value: this.masonry.bond
                },
                {
                    label: "Form",
                    type: "text",
                    name: "form",
                    value: this.masonry.form
                },
                {
                    label: "Direction",
                    type: "select",
                    options: this.options.orientations,
                    name: "direction",
                    value: this.masonry.direction
                },
                {
                    label: "Bonding Material",
                    type: "text",
                    name: "bonding_material",
                    value: this.masonry.bonding_material
                },
                {
                    label: "Dimensions",
                    type: "text",
                    name: "dimensions",
                    value: this.masonry.dimensions
                },
                {
                    label: "Worked Stones",
                    type: "text",
                    name: "worked_stones",
                    value: this.masonry.worked_stones
                },
                {
                    label: "Interpretation",
                    type: "select",
                    options: this.options.interpretations,
                    name: "interpretation",
                    value: this.masonry.interpretation
                },
                {
                    label: "Interpretation Comment",
                    type: "textArea",
                    name: "interpretation_comment",
                    value: this.masonry.interpretation_comment
                },
                {
                    label: "Other Comments",
                    type: "textArea",
                    name: "other",
                    value: this.masonry.other
                }
            ]
        };
    },
    created: function() {
        this.localMasonry = this.masonry;
    },
    methods: {
        valueChanged: function() {
            this.$emit("input", this.localMasonry);
        },
        grabChange: function(element, value) {
            this.localMasonry[element] = value;
            this.valueChanged();
        }
    },
    components: {
        question
    }
};
</script>
